mod Ul02 logic: 'cl'

loc rem 
  PREMIOVA ULOHA Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: pondelok 3.5.2004
  ******************************************************************************
  PRENOS: <cl>\2i\prenos\ulohy\ul02\<vase meno>\ul02.cl
          *************************************************
          *** odovzdat do 11.5.2001 (utorok) do 18:00 ***
          *************************************************
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohu: \it  8  \end. 
   \item \para Hodnotime len prvych 10 spravnych rieseni. 
   \item \para Ulohy rieste \bf  samostatne!  \end 
  \end

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

appldisp/1 Tex_f1_sum
  Prefix(70,2,Op(Ent('sum'),0),Arg(0))

appldisp/2 Tex2_triangleleft
  Infix(Arg(0),25,0,Op(Ent('vrtri'),0),Arg(1))

appldisp/1 Tex_f1_f
  Std('f',0)

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Combinatorial Functions over lists.  \end 

rem 
  \para \bf  Additive partitions.  \end 

fun Addl 'Tex_f1_sum'
  Addl(0) = 0
  Addl(v,w) = v+Addl(w)

pred/2 Addp 'Tex2_triangleleft'
  Addp(x,n) <-> Addl(x) = n & 0 !in x

rem 
  \para The binary predicate \ft Addp(x,n) \end holds if the list \ft x \end is 
  an additive partition of the number \ft n \end. The auxiliary function 
  \ft Addl(x) \end defined by list recursion is called the list addition 
  function. 

rem 
  \para \bf  Exercise.  \end Define the function 
  \header* fun Addps 'Tex_f1_f' \end \ft Addps(n) \end satisfying 
  \eq Spec_addps
    x in Addps(n) <-> Addp(x,n)
  \end
  \para Prove that the function has the required property. 

fun Addps 'Tex_f1_f'
  Addps(n) = Foo

thm Spec_addps
  x in Addps(n) <-> Addp(x,n)

